/* Q&D Test hack to test the use of the soundriver_client functions */
#include <fcntl.h>
#include <errno.h>
#include <stdio.h>
#include <sound/sound.h>
#include <sound/sounddriver.h>
unsigned char *data;
static playtag=0;
static pos=3;

port_t deviceOPort,ownerOPort,deviceIPort,ownerIPort,streamOPort,streamIPort,replyOPort,replyIPort;
int playp;

void play_completed(void *arg,int tag)
{
   printf("Completed\n");
   playp=tag;
}

#define READ_TAG 99

static unsigned char *readData;
static int readCount;

/* Create a recorded_data handler; the function's protocol is 
 * explained following the example.
 */

static void read_completed(void *arg, int tag, void *kernelData, 
                            int size) 
{
    /* Make sure this is the read stream. */
    if (tag == READ_TAG) {
        readCount = size; 
        readData = (unsigned char *)kernelData;
    }
}

void soundplay(int len, unsigned char *buf);



int main() {
   int protocol=0, err1=0, err2=0;
   msg_header_t *replyMsg = 0;
   static snddriver_handlers_t handlersI;

   sync(); sync(); sleep(1); 

   handlersI.recorded_data = read_completed;
   port_allocate(task_self(),&replyIPort);
   port_allocate(task_self(),&replyOPort);
   SNDAcquire(SND_ACCESS_OUT,10,0,0,0,0,&deviceOPort,&ownerOPort);
   SNDAcquire(SND_ACCESS_IN,10,0,0,0,0,&deviceIPort,&ownerIPort);

   err1= snddriver_stream_setup(deviceOPort, ownerOPort, SNDDRIVER_STREAM_TO_SNDOUT_44,vm_page_size/2,2,176400,352800,&protocol,&streamOPort);
   protocol=0;
   err2= snddriver_stream_setup(deviceIPort, ownerIPort, SNDDRIVER_STREAM_FROM_SNDIN,vm_page_size,1, 176400, 352800,&protocol,&streamIPort);
   fprintf(stderr,"soundinit: Done %d %d\n",err1,err2);
   if (err2 || err1) exit(0);
   replyMsg=malloc(MSG_SIZE_MAX);
   while (1) {
	    int err;
            err=snddriver_stream_start_reading(streamIPort,
                                               NULL, vm_page_size*2,
                                               READ_TAG,
                                               0,0,
                                               0,0,0,0,
                                               replyIPort);
 	  if (err==0) {
         	replyMsg->msg_size=MSG_SIZE_MAX;
         	replyMsg->msg_local_port=replyIPort;
         	while (msg_receive(replyMsg, MSG_OPTION_NONE,0)==RCV_SUCCESS)
         	   {
		   kern_return_t ret;
		   readCount=0;
         	   err=snddriver_reply_handler(replyMsg,&handlersI);
		   if (readCount>0) {
			printf("Playing...\n");
	 	   	soundplay(readCount,(unsigned char *)readData);
         	   }
		}
	}	
   }
}

void soundplay(int len, unsigned char *buf)
{
	int err;
   	msg_header_t *replyMsg = 0;
   	static snddriver_handlers_t handlersO;

        port_allocate(task_self(),&replyOPort);

	handlersO.completed=play_completed;
        err=snddriver_stream_start_writing(streamOPort,
                                               buf, len,
                                               1,
                                               0,0,
                                               0,0,0,0,0,0,
                                               replyOPort);
 	  if (err==0) {
         	replyMsg->msg_size=MSG_SIZE_MAX;
         	replyMsg->msg_local_port=replyOPort;
         	while (msg_receive(replyMsg, MSG_OPTION_NONE,0)==RCV_SUCCESS)
         	   {
		   kern_return_t ret;
		   playp=0;
         	   err=snddriver_reply_handler(replyMsg,&handlersO);
		   if (playp>0) {
			break;
         	   }
		}
	}
}
